import { Player,system,ItemTypes, world, MinecraftBlockTypes,MinecraftEntityTypes,ItemStack, DynamicPropertiesDefinition,PropertyRegistry } from '@minecraft/server';
system.events.beforeWatchdogTerminate.subscribe((event) => {
  event.cancel = true;
});
function moveItems(fromCont,toCont){
	let count=0;
	for (let i = 0; i < 27; i++) {
		let item = fromCont.getItem(i);
		if (item){count+=item.amount};
		fromCont.moveItem(i,i,toCont);
	};
	return count;
};
var del = undefined;
var location = undefined;
const sc= world.scoreboard;

world.afterEvents.worldInitialize.subscribe(async(event)=>{
	const { propertyRegistry } = event;
	let dynPropDeff = new DynamicPropertiesDefinition();
	dynPropDeff.defineNumber("carry");
	propertyRegistry.registerWorldDynamicProperties(dynPropDeff);
});


world.afterEvents.itemStartUseOn.subscribe(async(event)=>{
	let block = event.block;
	let itemStack = event.itemStack;
	let P = event.source;
	let faceLoc =event.blockFace;
	let item= P.getComponent("equipment_inventory").getEquipmentSlot("mainhand");
	if (world.getDynamicProperty("carry")=== undefined){world.setDynamicProperty("carry",1)};
	if (block.typeId == "minecraft:chest" && itemStack.typeId === "cc:chest_carrier"){
		if (true){
		let change="_"+String(world.getDynamicProperty("carry"));
		world.setDynamicProperty("carry", world.getDynamicProperty("carry")+1);
		let loc = P.location;
		loc.y=0;
		let ent = P.dimension.spawnEntity("cc:inv_ent", loc);
		ent.nameTag=change;
		let contTo = ent.getComponent("inventory").container;
		let contFrom = block.getComponent("inventory").container;
		let k = moveItems(contFrom,contTo);
		item.setItem(new ItemStack("cc:chest_carrier_full"));
		item.setLore(["§7id"+change, "§7Facing Direction: "+String(block.permutation.getState("facing_direction")),"Total "+String(k)+" items"]);
		block.setType(MinecraftBlockTypes.get("minecraft:air"));
		};};
		if (itemStack.typeId === "cc:chest_carrier_full"){
			del=block.location;
			let v = P.getViewDirection();
			let direction_xz;
			if (Math.abs(v.x) > Math.abs(v.z)){
				if (v.x < 0){
					direction_xz="5"
				}else{
					direction_xz="4"
				};
			}else{
				if (v.z < 0){
					direction_xz="3"
				}else{
					direction_xz="2"
				};
			};
			switch(faceLoc){
				case "down":
					del.y-=1;
					break;
				case "up":
					del.y+=1;
					break;
				case "west":
					del.x-=1;
					break;
				case "east":
					del.x+=1;
					break;
				case "north":
					del.z-=1;
					break;
				case "south":
					del.z+=1;
					break;
			};
			if (P.isSneaking){direction_xz=item.getLore()[1].slice(-1)};
			P.runCommand("setblock "+String(del.x)+" "+String(del.y)+" "+String(del.z)+' chest ["facing_direction":'+direction_xz+'] destroy');
			let newBlock = P.dimension.getBlock(del);
			let query={name:item.getLore()[0].split("d")[1]};
			let ent = P.dimension.getEntities(query);
			item.setItem(new ItemStack("cc:chest_carrier"));
			world.setDynamicProperty("carry", world.getDynamicProperty("carry")-1)
			if (ent.length>0){
				let contTo = ent[0].getComponent("inventory").container;
				let contFrom = newBlock.getComponent("inventory").container;
				moveItems(contTo,contFrom);
				ent[0].triggerEvent("despawn");
			}else{
				world.sendMessage("§cThe entity of chest carrier was removed.");
			};
	};
});
